#!/bin/sh

#create Pool
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool0 -warning 80%
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool1 -warning 80%
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool2 -warning 80%
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool3 -warning 80%

#initial driver
for i in {0..199}
do 
  mcsop chdrive -use candidate $i
  usleep 100000
done

#create mdisk(raid) 
cur1=0
cur2=0
cur3=0
cur4=0
cur5=0
cur6=0
cur7=0
cur8=0

lsdrive|awk 'NR>1{print $1,$6}'|while read id enid
do
   [ $enid -eq 1 ] && en1=$en1"$id"":" && let cur1+=1 && [ $cur1 -eq 12 ] && mcsop mkarray -drive ${en1%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool0 && cur1=0 && en1=""
   [ $enid -eq 2 ] && en2=$en2"$id"":" && let cur2+=1 && [ $cur2 -eq 12 ] && mcsop mkarray -drive ${en2%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool0 && cur2=0 && en2=""
   [ $enid -eq 3 ] && en3=$en3"$id"":" && let cur3+=1 && [ $cur3 -eq 12 ] && mcsop mkarray -drive ${en3%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool1 && cur3=0 && en3=""
   [ $enid -eq 4 ] && en4=$en4"$id"":" && let cur4+=1 && [ $cur4 -eq 12 ] && mcsop mkarray -drive ${en4%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool1 && cur4=0 && en4=""
   [ $enid -eq 5 ] && en5=$en5"$id"":" && let cur5+=1 && [ $cur5 -eq 12 ] && mcsop mkarray -drive ${en5%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool2 && cur5=0 && en5=""
   [ $enid -eq 6 ] && en6=$en6"$id"":" && let cur6+=1 && [ $cur6 -eq 12 ] && mcsop mkarray -drive ${en6%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool2 && cur6=0 && en6=""
   [ $enid -eq 7 ] && en7=$en7"$id"":" && let cur7+=1 && [ $cur7 -eq 12 ] && mcsop mkarray -drive ${en7%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool3 && cur7=0 && en7=""
   [ $enid -eq 8 ] && en8=$en8"$id"":" && let cur8+=1 && [ $cur8 -eq 12 ] && mcsop mkarray -drive ${en8%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool3 && cur8=0 && en8=""
done



#create vdisk(lun)
for j in {0..3}
do
  let m=2*j+1
  let n=2*j+2
  for i in {0..9}
  do
    echo "mcsop mkvdisk -accessiogrp $j -cache readwrite -iogrp $j -mdiskgrp $j -name node${m}_${i} -node $m -nofmtdisk -size 1825361100800 -unit b"
    mcsop mkvdisk -accessiogrp $j -cache readwrite -iogrp $j -mdiskgrp $j -name node${m}_${i} -node $m -nofmtdisk -size 1825361100800 -unit b
    usleep 500000
  done
  for i in {0..9}
  do
    echo "mcsop mkvdisk -accessiogrp $j -cache readwrite -iogrp $j -mdiskgrp $j -name node${n}_${i} -node $n -nofmtdisk -size 1825361100800 -unit b"
    mcsop mkvdisk -accessiogrp $j -cache readwrite -iogrp $j -mdiskgrp $j -name node${n}_${i} -node $n -nofmtdisk -size 1825361100800 -unit b
    usleep 500000
  done
done


#create hosts
mcsop mkhost -fcwwpn 100000109b5cab54:100000109b5cab55:100000109b5caba3:100000109b5caba4 -force -iogrp 0:1:2:3 -name node121 -type generic
mcsop mkhost -fcwwpn 100000109b527c7b:100000109b527c7c:100000109b418216:100000109b418217 -force -iogrp 0:1:2:3 -name node123 -type generic
mcsop mkhost -fcwwpn 100000109b211874:100000109b211875:100000109b50a03d:100000109b50a03e -force -iogrp 0:1:2:3 -name node124 -type generic
mcsop mkhost -fcwwpn 100000109b606b60:100000109b606b61:100000109b606b66:100000109b606b67 -force -iogrp 0:1:2:3 -name node125 -type generic
mcsop mkhost -fcwwpn 100000109b1d2740:100000109b1d2741:100000109b2119d6:100000109b2119d7 -force -iogrp 0:1:2:3 -name node126 -type generic
mcsop mkhost -fcwwpn 100000109b606b54:100000109b606b55:100000109b50a43b:100000109b50a43c -force -iogrp 0:1:2:3 -name node127 -type generic
mcsop mkhost -fcwwpn 100000109b5ca928:100000109b5ca929:100000109b5cac5c:100000109b5cac5d -force -iogrp 0:1:2:3 -name node128 -type generic
mcsop mkhost -fcwwpn 100000109b5621d0:100000109b5621d1:100000109b5688b6:100000109b5688b7 -force -iogrp 0:1:2:3 -name node129 -type generic

#map lun to hosts
for i in {0..79}
do 
  for j in {0..7}
  do 
    mcsop mkvdiskhostmap -force -host $j $i 
	usleep 100000
  done
done


